//+------------------------------------------------------------------+
//|                                       Salha-Crossover_Signal.mq4 |
//|                                   Copyright  2007, Khalid Salha |
//+------------------------------------------------------------------+

/*
  +------------------------------------------------------------------+
  | In this indicator you will see the crossover between the LWMA5   |
  | with SMA8 when they will crossover the will show us the signal   |
  | with Arrow.                                                      |
  +------------------------------------------------------------------+
*/   
#property copyright "Copyright  2007, Khalid Salha"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

double CrossUp[];
double CrossDown[];
extern int FasterWMA = 5;
extern int SlowerSMA = 8;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double fasterWMAnow, slowerSMAnow, fasterWMAprevious, slowerSMAprevious, fasterWMAafter, slowerSMAafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      fasterWMAnow = iMA(NULL, 0, FasterWMA, 0, MODE_LWMA, PRICE_CLOSE, i);
      fasterWMAprevious = iMA(NULL, 0, FasterWMA, 0, MODE_LWMA, PRICE_CLOSE, i+1);
      fasterWMAafter = iMA(NULL, 0, FasterWMA, 0, MODE_LWMA, PRICE_CLOSE, i-1);

      slowerSMAnow = iMA(NULL, 0, SlowerSMA, 0, MODE_SMA, PRICE_CLOSE, i);
      slowerSMAprevious = iMA(NULL, 0, SlowerSMA, 0, MODE_SMA, PRICE_CLOSE, i+1);
      slowerSMAafter = iMA(NULL, 0, SlowerSMA, 0, MODE_SMA, PRICE_CLOSE, i-1);
      
      if ((fasterWMAnow > slowerSMAnow) && (fasterWMAprevious < slowerSMAprevious) && (fasterWMAafter > slowerSMAafter)) {
         CrossUp[i] = Low[i] - Range*0.5;
      }
      else if ((fasterWMAnow < slowerSMAnow) && (fasterWMAprevious > slowerSMAprevious) && (fasterWMAafter < slowerSMAafter)) {
         CrossDown[i] = High[i] + Range*0.5;
      }
   }
   return(0);
}

